{{ Robot UI Board }}
''  1x mouse
''  1x keyboard
''  1x VGA
''  1x Inter-Prop Ring

CON

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

OBJ 
  keyboard      : "Keyboard"                            '1 COG
  mouse         : "Mouse"                               '1 COG
  
  vga           : "VGA_Text"                            '1 COG
  
  debug         : "Debug_PC"                            '1 COG

'  ipr           : "ipr"                                 '1 COG

  config        : "config"                              'no COG required
  appconfig     : "appconfig"                           'no COG required

VAR
  long cog
  long Back_Stack[100] 
  long source,channel,reclen
'  long rxtempbuffer[IPR#PACKETSIZE]
  byte strbuffer[80]
  long CamPan, CamTilt
  long sendbuffer[10]
    
Pub Start | check, char,SendServo
  config.Init(@configinfo)                              'initialize config setup
  waitcnt(clkfreq*3 + cnt)                              'delay for debugging
  
  CamPan := CamTilt := 1500
  SendServo := 0
  
  ' start the PC debug object
  debug.startx(config.GetPin(CONFIG#DEBUG_RX),config.GetPin(CONFIG#DEBUG_TX),115200)

  debug.strln(string("RB UI V1.0"))

  keyboard.start(config.GetPin(CONFIG#KEYBOARD1_DATA),config.GetPin(CONFIG#KEYBOARD1_CLK))

  mouse.start(config.GetPin(CONFIG#MOUSE1_DATA),config.GetPin(CONFIG#MOUSE1_CLK))

  vga.start(config.GetPin(CONFIG#VGA1))
  
  vga.str(string("RB UI V1.0",13))

{  ' start Ring
  if IPR.start(config.GetPin(APPCONFIG#IPR_RX), config.GetPin(APPCONFIG#IPR_TX), IPR#RUINODE) == 0
    debug.strln(string("IPR Start failed"))
}
  cog := cognew(BackProcessing,@Back_Stack) + 1   

  'Handle keyboard
  repeat
    if char := keyboard.key
      case char
        $C0:                    'Left Arrow
          CamPan -= 10
          CamPan #>= 1000
          SendServo := 1
        $C1:                    'Right Arrow
          CamPan += 10
          CamPan <#= 2000
          SendServo := 1
        $C2:                    'Up Arrow
          CamTilt += 10
          CamTilt <#= 2000
          SendServo := 1
        $C3:                    'Down Arrow        
          CamTilt -= 10
          CamTilt #>= 1000
          SendServo := 1

    if SendServo == 1
      LONG[@sendbuffer] := CamPan
      LONG[@sendbuffer+4] := CamTilt
{      IPR.sendbuffer(IPR#RSENSORNODE,IPR#CAMSERVOCHANNEL,@sendbuffer,8)}
      SendServo := 0
         
PUB BackProcessing
'Handle remote requests
  repeat
    channel := 0
{    if IPR.recbuffer(@source,@channel,%00000,@strbuffer,@rxtempbuffer,@reclen,TRUE) == true
      CASE channel
        IPR#VGACHANNEL:
          vga.str(string("IPR:("))
          vga.dec(source)
          vga.str(string(":"))
          vga.dec(channel)
          vga.str(string("["))
          vga.dec(reclen)
          vga.str(string("]) "))
          vga.str(@strbuffer)
          vga.out(13)
}          
DAT
'configuration table for this project, list if pin usage and ntsc/pal mode
configinfo    word CONFIG#NOT_USED              'pin 0
              word CONFIG#NOT_USED              'pin 1
              word CONFIG#NOT_USED              'pin 2
              word CONFIG#NOT_USED              'pin 3
              word CONFIG#NOT_USED              'pin 4
              word CONFIG#NOT_USED              'pin 5
              word CONFIG#NOT_USED              'pin 6
              word CONFIG#NOT_USED              'pin 7
              word APPCONFIG#IPR_TX             'pin 8
              word APPCONFIG#IPR_RX             'pin 9
              word CONFIG#NOT_USED              'pin 10
              word CONFIG#NOT_USED              'pin 11
              word CONFIG#NOT_USED              'pin 12
              word CONFIG#NOT_USED              'pin 13
              word CONFIG#NOT_USED              'pin 14
              word CONFIG#NOT_USED              'pin 15
              word CONFIG#VGA1                  'pin 16
              word CONFIG#VGA1                  'pin 17
              word CONFIG#VGA1                  'pin 18
              word CONFIG#VGA1                  'pin 19
              word CONFIG#VGA1                  'pin 20
              word CONFIG#VGA1                  'pin 21
              word CONFIG#VGA1                  'pin 22
              word CONFIG#VGA1                  'pin 23
              word CONFIG#MOUSE1_DATA           'pin 24
              word CONFIG#MOUSE1_CLK            'pin 25
              word CONFIG#KEYBOARD1_DATA        'pin 26
              word CONFIG#KEYBOARD1_CLK         'pin 27
              word CONFIG#I2C_SCL1              'pin 28
              word CONFIG#I2C_SDA1              'pin 29
              word CONFIG#DEBUG_TX              'pin 30
              word CONFIG#DEBUG_RX              'pin 31
              byte CONFIG#NTSC              